git-rebase.shon commit Merge branch 'pw/rebase-keep-empty-fixes' (d892bee)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_STUCKLONG=t
   9OPTIONS_SPEC="\
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  11git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  12git rebase --continue | --abort | --skip | --edit-todo
  13--
  14 Available options are
  15v,verbose!         display a diffstat of what changed upstream
  16q,quiet!           be quiet. implies --no-stat
  17autostash          automatically stash/stash pop before and after
  18fork-point         use 'merge-base --fork-point' to refine upstream
  19onto=!             rebase onto given branch instead of upstream
  20p,preserve-merges! try to recreate merges instead of ignoring them
  21s,strategy=!       use the given merge strategy
  22no-ff!             cherry-pick all commits, even if unchanged
  23m,merge!           use merging strategies to rebase
  24i,interactive!     let the user edit the list of commits to rebase
  25x,exec=!           add exec lines after each commit of the editable list
  26k,keep-empty       preserve empty commits during rebase
  27allow-empty-message allow rebasing commits with empty messages
  28f,force-rebase!    force rebase even if branch is up to date
  29X,strategy-option=! pass the argument through to the merge strategy
  30stat!              display a diffstat of what changed upstream
  31n,no-stat!         do not show diffstat of what changed upstream
  32verify             allow pre-rebase hook to run
  33rerere-autoupdate  allow rerere to update index with resolved conflicts
  34root!              rebase all reachable commits up to the root(s)
  35autosquash         move commits that begin with squash!/fixup! under -i
  36committer-date-is-author-date! passed to 'git am'
  37ignore-date!       passed to 'git am'
  38signoff            passed to 'git am'
  39whitespace=!       passed to 'git apply'
  40ignore-whitespace! passed to 'git apply'
  41C=!                passed to 'git apply'
  42S,gpg-sign?        GPG-sign commits
  43 Actions:
  44continue!          continue
  45abort!             abort and check out the original branch
  46skip!              skip current patch and continue
  47edit-todo!         edit the todo list during an interactive rebase
  48quit!              abort but keep HEAD where it is
  49show-current-patch! show the patch file being applied or merged
  50"
  51. git-sh-setup
  52set_reflog_action rebase
  53require_work_tree_exists
  54cd_to_toplevel
  55
  56LF='
  57'
  58ok_to_skip_pre_rebase=
  59resolvemsg="
  60$(gettext 'Resolve all conflicts manually, mark them as resolved with
  61"git add/rm <conflicted_files>", then run "git rebase --continue".
  62You can instead skip this commit: run "git rebase --skip".
  63To abort and get back to the state before "git rebase", run "git rebase --abort".')
  64"
  65squash_onto=
  66unset onto
  67unset restrict_revision
  68cmd=
  69strategy=
  70strategy_opts=
  71do_merge=
  72merge_dir="$GIT_DIR"/rebase-merge
  73apply_dir="$GIT_DIR"/rebase-apply
  74verbose=
  75diffstat=
  76test "$(git config --bool rebase.stat)" = true && diffstat=t
  77autostash="$(git config --bool rebase.autostash || echo false)"
  78fork_point=auto
  79git_am_opt=
  80git_format_patch_opt=
  81rebase_root=
  82force_rebase=
  83allow_rerere_autoupdate=
  84# Non-empty if a rebase was in progress when 'git rebase' was invoked
  85in_progress=
  86# One of {am, merge, interactive}
  87type=
  88# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  89state_dir=
  90# One of {'', continue, skip, abort}, as parsed from command line
  91action=
  92preserve_merges=
  93autosquash=
  94keep_empty=
  95allow_empty_message=
  96test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
  97case "$(git config --bool commit.gpgsign)" in
  98true)   gpg_sign_opt=-S ;;
  99*)      gpg_sign_opt= ;;
 100esac
 101
 102read_basic_state () {
 103        test -f "$state_dir/head-name" &&
 104        test -f "$state_dir/onto" &&
 105        head_name=$(cat "$state_dir"/head-name) &&
 106        onto=$(cat "$state_dir"/onto) &&
 107        # We always write to orig-head, but interactive rebase used to write to
 108        # head. Fall back to reading from head to cover for the case that the
 109        # user upgraded git with an ongoing interactive rebase.
 110        if test -f "$state_dir"/orig-head
 111        then
 112                orig_head=$(cat "$state_dir"/orig-head)
 113        else
 114                orig_head=$(cat "$state_dir"/head)
 115        fi &&
 116        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 117        test -f "$state_dir"/verbose && verbose=t
 118        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 119        test -f "$state_dir"/strategy_opts &&
 120                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 121        test -f "$state_dir"/allow_rerere_autoupdate &&
 122                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 123        test -f "$state_dir"/gpg_sign_opt &&
 124                gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
 125}
 126
 127write_basic_state () {
 128        echo "$head_name" > "$state_dir"/head-name &&
 129        echo "$onto" > "$state_dir"/onto &&
 130        echo "$orig_head" > "$state_dir"/orig-head &&
 131        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 132        test t = "$verbose" && : > "$state_dir"/verbose
 133        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 134        test -n "$strategy_opts" && echo "$strategy_opts" > \
 135                "$state_dir"/strategy_opts
 136        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 137                "$state_dir"/allow_rerere_autoupdate
 138        test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
 139}
 140
 141output () {
 142        case "$verbose" in
 143        '')
 144                output=$("$@" 2>&1 )
 145                status=$?
 146                test $status != 0 && printf "%s\n" "$output"
 147                return $status
 148                ;;
 149        *)
 150                "$@"
 151                ;;
 152        esac
 153}
 154
 155move_to_original_branch () {
 156        case "$head_name" in
 157        refs/*)
 158                message="rebase finished: $head_name onto $onto"
 159                git update-ref -m "$message" \
 160                        $head_name $(git rev-parse HEAD) $orig_head &&
 161                git symbolic-ref \
 162                        -m "rebase finished: returning to $head_name" \
 163                        HEAD $head_name ||
 164                die "$(eval_gettext "Could not move back to \$head_name")"
 165                ;;
 166        esac
 167}
 168
 169apply_autostash () {
 170        if test -f "$state_dir/autostash"
 171        then
 172                stash_sha1=$(cat "$state_dir/autostash")
 173                if git stash apply $stash_sha1 >/dev/null 2>&1
 174                then
 175                        echo "$(gettext 'Applied autostash.')" >&2
 176                else
 177                        git stash store -m "autostash" -q $stash_sha1 ||
 178                        die "$(eval_gettext "Cannot store \$stash_sha1")"
 179                        gettext 'Applying autostash resulted in conflicts.
 180Your changes are safe in the stash.
 181You can run "git stash pop" or "git stash drop" at any time.
 182' >&2
 183                fi
 184        fi
 185}
 186
 187finish_rebase () {
 188        rm -f "$(git rev-parse --git-path REBASE_HEAD)"
 189        apply_autostash &&
 190        { git gc --auto || true; } &&
 191        rm -rf "$state_dir"
 192}
 193
 194run_specific_rebase () {
 195        if [ "$interactive_rebase" = implied ]; then
 196                GIT_EDITOR=:
 197                export GIT_EDITOR
 198                autosquash=
 199        fi
 200        . git-rebase--$type
 201        git_rebase__$type${preserve_merges:+__preserve_merges}
 202        ret=$?
 203        if test $ret -eq 0
 204        then
 205                finish_rebase
 206        elif test $ret -eq 2 # special exit status for rebase -i
 207        then
 208                apply_autostash &&
 209                rm -rf "$state_dir" &&
 210                die "Nothing to do"
 211        fi
 212        exit $ret
 213}
 214
 215run_pre_rebase_hook () {
 216        if test -z "$ok_to_skip_pre_rebase" &&
 217           test -x "$(git rev-parse --git-path hooks/pre-rebase)"
 218        then
 219                "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
 220                die "$(gettext "The pre-rebase hook refused to rebase.")"
 221        fi
 222}
 223
 224test -f "$apply_dir"/applying &&
 225        die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
 226
 227if test -d "$apply_dir"
 228then
 229        type=am
 230        state_dir="$apply_dir"
 231elif test -d "$merge_dir"
 232then
 233        if test -f "$merge_dir"/interactive
 234        then
 235                type=interactive
 236                interactive_rebase=explicit
 237        else
 238                type=merge
 239        fi
 240        state_dir="$merge_dir"
 241fi
 242test -n "$type" && in_progress=t
 243
 244total_argc=$#
 245while test $# != 0
 246do
 247        case "$1" in
 248        --no-verify)
 249                ok_to_skip_pre_rebase=yes
 250                ;;
 251        --verify)
 252                ok_to_skip_pre_rebase=
 253                ;;
 254        --continue|--skip|--abort|--quit|--edit-todo|--show-current-patch)
 255                test $total_argc -eq 2 || usage
 256                action=${1##--}
 257                ;;
 258        --onto=*)
 259                onto="${1#--onto=}"
 260                ;;
 261        --exec=*)
 262                cmd="${cmd}exec ${1#--exec=}${LF}"
 263                test -z "$interactive_rebase" && interactive_rebase=implied
 264                ;;
 265        --interactive)
 266                interactive_rebase=explicit
 267                ;;
 268        --keep-empty)
 269                keep_empty=yes
 270                ;;
 271        --allow-empty-message)
 272                allow_empty_message=--allow-empty-message
 273                ;;
 274        --no-keep-empty)
 275                keep_empty=
 276                ;;
 277        --preserve-merges)
 278                preserve_merges=t
 279                test -z "$interactive_rebase" && interactive_rebase=implied
 280                ;;
 281        --autosquash)
 282                autosquash=t
 283                ;;
 284        --no-autosquash)
 285                autosquash=
 286                ;;
 287        --fork-point)
 288                fork_point=t
 289                ;;
 290        --no-fork-point)
 291                fork_point=
 292                ;;
 293        --merge)
 294                do_merge=t
 295                ;;
 296        --strategy-option=*)
 297                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
 298                do_merge=t
 299                test -z "$strategy" && strategy=recursive
 300                ;;
 301        --strategy=*)
 302                strategy="${1#--strategy=}"
 303                do_merge=t
 304                ;;
 305        --no-stat)
 306                diffstat=
 307                ;;
 308        --stat)
 309                diffstat=t
 310                ;;
 311        --autostash)
 312                autostash=true
 313                ;;
 314        --no-autostash)
 315                autostash=false
 316                ;;
 317        --verbose)
 318                verbose=t
 319                diffstat=t
 320                GIT_QUIET=
 321                ;;
 322        --quiet)
 323                GIT_QUIET=t
 324                git_am_opt="$git_am_opt -q"
 325                verbose=
 326                diffstat=
 327                ;;
 328        --whitespace=*)
 329                git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
 330                case "${1#--whitespace=}" in
 331                fix|strip)
 332                        force_rebase=t
 333                        ;;
 334                esac
 335                ;;
 336        --ignore-whitespace)
 337                git_am_opt="$git_am_opt $1"
 338                ;;
 339        --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
 340                git_am_opt="$git_am_opt $1"
 341                force_rebase=t
 342                ;;
 343        -C*)
 344                git_am_opt="$git_am_opt $1"
 345                ;;
 346        --root)
 347                rebase_root=t
 348                ;;
 349        --force-rebase|--no-ff)
 350                force_rebase=t
 351                ;;
 352        --rerere-autoupdate|--no-rerere-autoupdate)
 353                allow_rerere_autoupdate="$1"
 354                ;;
 355        --gpg-sign)
 356                gpg_sign_opt=-S
 357                ;;
 358        --gpg-sign=*)
 359                gpg_sign_opt="-S${1#--gpg-sign=}"
 360                ;;
 361        --)
 362                shift
 363                break
 364                ;;
 365        *)
 366                usage
 367                ;;
 368        esac
 369        shift
 370done
 371test $# -gt 2 && usage
 372
 373if test -n "$action"
 374then
 375        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 376        # Only interactive rebase uses detailed reflog messages
 377        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 378        then
 379                GIT_REFLOG_ACTION="rebase -i ($action)"
 380                export GIT_REFLOG_ACTION
 381        fi
 382fi
 383
 384if test "$action" = "edit-todo" && test "$type" != "interactive"
 385then
 386        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 387fi
 388
 389case "$action" in
 390continue)
 391        # Sanity check
 392        git rev-parse --verify HEAD >/dev/null ||
 393                die "$(gettext "Cannot read HEAD")"
 394        git update-index --ignore-submodules --refresh &&
 395        git diff-files --quiet --ignore-submodules || {
 396                echo "$(gettext "You must edit all merge conflicts and then
 397mark them as resolved using git add")"
 398                exit 1
 399        }
 400        read_basic_state
 401        run_specific_rebase
 402        ;;
 403skip)
 404        output git reset --hard HEAD || exit $?
 405        read_basic_state
 406        run_specific_rebase
 407        ;;
 408abort)
 409        git rerere clear
 410        read_basic_state
 411        case "$head_name" in
 412        refs/*)
 413                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 414                die "$(eval_gettext "Could not move back to \$head_name")"
 415                ;;
 416        esac
 417        output git reset --hard $orig_head
 418        finish_rebase
 419        exit
 420        ;;
 421quit)
 422        exec rm -rf "$state_dir"
 423        ;;
 424edit-todo)
 425        run_specific_rebase
 426        ;;
 427show-current-patch)
 428        run_specific_rebase
 429        die "BUG: run_specific_rebase is not supposed to return here"
 430        ;;
 431esac
 432
 433# Make sure no rebase is in progress
 434if test -n "$in_progress"
 435then
 436        state_dir_base=${state_dir##*/}
 437        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 438        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 439        die "
 440$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 441I wonder if you are in the middle of another rebase.  If that is the
 442case, please try
 443        $cmd_live_rebase
 444If that is not the case, please
 445        $cmd_clear_stale_rebase
 446and run me again.  I am stopping in case you still have something
 447valuable there.')"
 448fi
 449
 450if test -n "$rebase_root" && test -z "$onto"
 451then
 452        test -z "$interactive_rebase" && interactive_rebase=implied
 453fi
 454
 455if test -n "$interactive_rebase"
 456then
 457        type=interactive
 458        state_dir="$merge_dir"
 459elif test -n "$do_merge"
 460then
 461        type=merge
 462        state_dir="$merge_dir"
 463else
 464        type=am
 465        state_dir="$apply_dir"
 466fi
 467
 468if test -t 2 && test -z "$GIT_QUIET"
 469then
 470        git_format_patch_opt="$git_format_patch_opt --progress"
 471fi
 472
 473if test -z "$rebase_root"
 474then
 475        case "$#" in
 476        0)
 477                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 478                        --verify -q @{upstream} 2>/dev/null)
 479                then
 480                        . git-parse-remote
 481                        error_on_missing_default_upstream "rebase" "rebase" \
 482                                "against" "git rebase $(gettext '<branch>')"
 483                fi
 484
 485                test "$fork_point" = auto && fork_point=t
 486                ;;
 487        *)      upstream_name="$1"
 488                if test "$upstream_name" = "-"
 489                then
 490                        upstream_name="@{-1}"
 491                fi
 492                shift
 493                ;;
 494        esac
 495        upstream=$(peel_committish "${upstream_name}") ||
 496        die "$(eval_gettext "invalid upstream '\$upstream_name'")"
 497        upstream_arg="$upstream_name"
 498else
 499        if test -z "$onto"
 500        then
 501                empty_tree=$(git hash-object -t tree /dev/null)
 502                onto=$(git commit-tree $empty_tree </dev/null)
 503                squash_onto="$onto"
 504        fi
 505        unset upstream_name
 506        unset upstream
 507        test $# -gt 1 && usage
 508        upstream_arg=--root
 509fi
 510
 511# Make sure the branch to rebase onto is valid.
 512onto_name=${onto-"$upstream_name"}
 513case "$onto_name" in
 514*...*)
 515        if      left=${onto_name%...*} right=${onto_name#*...} &&
 516                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 517        then
 518                case "$onto" in
 519                ?*"$LF"?*)
 520                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 521                        ;;
 522                '')
 523                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 524                        ;;
 525                esac
 526        else
 527                die "$(eval_gettext "\$onto_name: there is no merge base")"
 528        fi
 529        ;;
 530*)
 531        onto=$(peel_committish "$onto_name") ||
 532        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 533        ;;
 534esac
 535
 536# If the branch to rebase is given, that is the branch we will rebase
 537# $branch_name -- branch/commit being rebased, or HEAD (already detached)
 538# $orig_head -- commit object name of tip of the branch before rebasing
 539# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 540switch_to=
 541case "$#" in
 5421)
 543        # Is it "rebase other $branchname" or "rebase other $commit"?
 544        branch_name="$1"
 545        switch_to="$1"
 546
 547        # Is it a local branch?
 548        if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
 549           orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
 550        then
 551                head_name="refs/heads/$branch_name"
 552        # If not is it a valid ref (branch or commit)?
 553        elif orig_head=$(git rev-parse -q --verify "$branch_name")
 554        then
 555                head_name="detached HEAD"
 556
 557        else
 558                die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
 559        fi
 560        ;;
 5610)
 562        # Do not need to switch branches, we are already on it.
 563        if branch_name=$(git symbolic-ref -q HEAD)
 564        then
 565                head_name=$branch_name
 566                branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
 567        else
 568                head_name="detached HEAD"
 569                branch_name=HEAD
 570        fi
 571        orig_head=$(git rev-parse --verify HEAD) || exit
 572        ;;
 573*)
 574        die "BUG: unexpected number of arguments left to parse"
 575        ;;
 576esac
 577
 578if test "$fork_point" = t
 579then
 580        new_upstream=$(git merge-base --fork-point "$upstream_name" \
 581                        "${switch_to:-HEAD}")
 582        if test -n "$new_upstream"
 583        then
 584                restrict_revision=$new_upstream
 585        fi
 586fi
 587
 588if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
 589then
 590        stash_sha1=$(git stash create "autostash") ||
 591        die "$(gettext 'Cannot autostash')"
 592
 593        mkdir -p "$state_dir" &&
 594        echo $stash_sha1 >"$state_dir/autostash" &&
 595        stash_abbrev=$(git rev-parse --short $stash_sha1) &&
 596        echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
 597        git reset --hard
 598fi
 599
 600require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 601
 602# Now we are rebasing commits $upstream..$orig_head (or with --root,
 603# everything leading up to $orig_head) on top of $onto
 604
 605# Check if we are already based on $onto with linear history,
 606# but this should be done only when upstream and onto are the same
 607# and if this is not an interactive rebase.
 608mb=$(git merge-base "$onto" "$orig_head")
 609if test "$type" != interactive && test "$upstream" = "$onto" &&
 610        test "$mb" = "$onto" && test -z "$restrict_revision" &&
 611        # linear history?
 612        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 613then
 614        if test -z "$force_rebase"
 615        then
 616                # Lazily switch to the target branch if needed...
 617                test -z "$switch_to" ||
 618                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
 619                        git checkout -q "$switch_to" --
 620                if test "$branch_name" = "HEAD" &&
 621                         ! git symbolic-ref -q HEAD
 622                then
 623                        say "$(eval_gettext "HEAD is up to date.")"
 624                else
 625                        say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 626                fi
 627                finish_rebase
 628                exit 0
 629        else
 630                if test "$branch_name" = "HEAD" &&
 631                         ! git symbolic-ref -q HEAD
 632                then
 633                        say "$(eval_gettext "HEAD is up to date, rebase forced.")"
 634                else
 635                        say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 636                fi
 637        fi
 638fi
 639
 640# If a hook exists, give it a chance to interrupt
 641run_pre_rebase_hook "$upstream_arg" "$@"
 642
 643if test -n "$diffstat"
 644then
 645        if test -n "$verbose"
 646        then
 647                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 648        fi
 649        # We want color (if set), but no pager
 650        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 651fi
 652
 653test "$type" = interactive && run_specific_rebase
 654
 655# Detach HEAD and reset the tree
 656say "$(gettext "First, rewinding head to replay your work on top of it...")"
 657
 658GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
 659        git checkout -q "$onto^0" || die "could not detach HEAD"
 660git update-ref ORIG_HEAD $orig_head
 661
 662# If the $onto is a proper descendant of the tip of the branch, then
 663# we just fast-forwarded.
 664if test "$mb" = "$orig_head"
 665then
 666        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 667        move_to_original_branch
 668        finish_rebase
 669        exit 0
 670fi
 671
 672if test -n "$rebase_root"
 673then
 674        revisions="$onto..$orig_head"
 675else
 676        revisions="${restrict_revision-$upstream}..$orig_head"
 677fi
 678
 679run_specific_rebase